package tapl5

/** Two-phase inferencer, first collect constraints, then solve them. */
class TwoPhaseInferencer extends TypeInferencers {
  import Type._

  type Constraint = Pair[Type, Type]

  val noContraints: List[Constraint] = Nil
  case class TypingResult(tpe: Type, c: List[Constraint])

  /** Type <code>t</code> in <code>env</code> and return its type and a
   *  constraint list.
   */
  def collect(env: Env, t: Term): TypingResult = t match {
    // to be completed
    case Zero =>
      TypingResult(TypeNat, noContraints)
    // to be completed
  }

  def unify(c: List[Constraint]): Substitution =
    emptySubst // to be replaced

  override def typeOf(t: Term): Type = try {
    TypeNat // to be replaced
  } catch {
    case TypeError(msg) =>
      Console.println("type error: " + msg)
      null
  }

}
